/* Application.c generated by valac 0.56.14, the Vala compiler
 * generated from Application.vala, do not modify */

/*
* Copyright (c) 2017 Felipe Escoto (https://github.com/Philip-Scott/Spice-up)
*
* This program is free software; you can redistribute it and/or
* modify it under the terms of the GNU General Public
* License as published by the Free Software Foundation; either
* version 2 of the License, or (at your option) any later version.
*
* This program is distributed in the hope that it will be useful,
* but WITHOUT ANY WARRANTY; without even the implied warranty of
* MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
* General Public License for more details.
*
* You should have received a copy of the GNU General Public
* License along with this program; if not, write to the
* Free Software Foundation, Inc., 59 Temple Place - Suite 330,
* Boston, MA 02111-1307, USA.
*
* Authored by: Felipe Escoto <felescoto95@hotmail.com>
*/

#include <glib.h>
#include <granite.h>
#include <glib-object.h>
#include <stdlib.h>
#include <string.h>
#include <gtk/gtk.h>
#include <gee.h>
#include <gio/gio.h>
#include <glib/gi18n-lib.h>
#include <locale.h>

#define SPICE_APPLICATION_PROGRAM_NAME N_ ("Spice-Up")
#define SPICE_APPLICATION_ABOUT_STOCK N_ ("About Spice-Up")
#define SPICE_APPLICATION_APP_ID "com.github.philip_scott.spice-up"
#define SPICE_APPLICATION_RESOURCE_PATH "/com/github/philip-scott/spice-up/"
#define SPICE_APPLICATION_APP_NAME "Spice-Up"
#if !defined(VALA_EXTERN)
#if defined(_MSC_VER)
#define VALA_EXTERN __declspec(dllexport) extern
#elif __GNUC__ >= 4
#define VALA_EXTERN __attribute__((visibility("default"))) extern
#else
#define VALA_EXTERN extern
#endif
#endif

#define SPICE_SERVICES_TYPE_SETTINGS (spice_services_settings_get_type ())
#define SPICE_SERVICES_SETTINGS(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), SPICE_SERVICES_TYPE_SETTINGS, SpiceServicesSettings))
#define SPICE_SERVICES_SETTINGS_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), SPICE_SERVICES_TYPE_SETTINGS, SpiceServicesSettingsClass))
#define SPICE_SERVICES_IS_SETTINGS(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), SPICE_SERVICES_TYPE_SETTINGS))
#define SPICE_SERVICES_IS_SETTINGS_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), SPICE_SERVICES_TYPE_SETTINGS))
#define SPICE_SERVICES_SETTINGS_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), SPICE_SERVICES_TYPE_SETTINGS, SpiceServicesSettingsClass))

typedef struct _SpiceServicesSettings SpiceServicesSettings;
typedef struct _SpiceServicesSettingsClass SpiceServicesSettingsClass;

#define SPICE_TYPE_APPLICATION (spice_application_get_type ())
#define SPICE_APPLICATION(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), SPICE_TYPE_APPLICATION, SpiceApplication))
#define SPICE_APPLICATION_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), SPICE_TYPE_APPLICATION, SpiceApplicationClass))
#define SPICE_IS_APPLICATION(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), SPICE_TYPE_APPLICATION))
#define SPICE_IS_APPLICATION_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), SPICE_TYPE_APPLICATION))
#define SPICE_APPLICATION_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), SPICE_TYPE_APPLICATION, SpiceApplicationClass))

typedef struct _SpiceApplication SpiceApplication;
typedef struct _SpiceApplicationClass SpiceApplicationClass;
typedef struct _SpiceApplicationPrivate SpiceApplicationPrivate;

#define SPICE_TYPE_WINDOW (spice_window_get_type ())
#define SPICE_WINDOW(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), SPICE_TYPE_WINDOW, SpiceWindow))
#define SPICE_WINDOW_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), SPICE_TYPE_WINDOW, SpiceWindowClass))
#define SPICE_IS_WINDOW(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), SPICE_TYPE_WINDOW))
#define SPICE_IS_WINDOW_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), SPICE_TYPE_WINDOW))
#define SPICE_WINDOW_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), SPICE_TYPE_WINDOW, SpiceWindowClass))

typedef struct _SpiceWindow SpiceWindow;
typedef struct _SpiceWindowClass SpiceWindowClass;
enum  {
	SPICE_APPLICATION_0_PROPERTY,
	SPICE_APPLICATION_NUM_PROPERTIES
};
static GParamSpec* spice_application_properties[SPICE_APPLICATION_NUM_PROPERTIES];
#define _g_object_unref0(var) ((var == NULL) ? NULL : (var = (g_object_unref (var), NULL)))
#define _g_free0(var) (var = (g_free (var), NULL))

struct _SpiceApplication {
	GtkApplication parent_instance;
	SpiceApplicationPrivate * priv;
	gboolean running;
};

struct _SpiceApplicationClass {
	GtkApplicationClass parent_class;
};

struct _SpiceApplicationPrivate {
	GeeHashMap* opened_files;
};

VALA_EXTERN gboolean DEBUG;
gboolean DEBUG = FALSE;
VALA_EXTERN SpiceServicesSettings* spice_settings;
SpiceServicesSettings* spice_settings = NULL;
VALA_EXTERN gchar* spice_DATA_DIR;
gchar* spice_DATA_DIR = NULL;
static gint SpiceApplication_private_offset;
static gpointer spice_application_parent_class = NULL;
VALA_EXTERN SpiceApplication* spice_application__instance;
SpiceApplication* spice_application__instance = NULL;

VALA_EXTERN GType spice_services_settings_get_type (void) G_GNUC_CONST ;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (SpiceServicesSettings, g_object_unref)
VALA_EXTERN GType spice_application_get_type (void) G_GNUC_CONST ;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (SpiceApplication, g_object_unref)
VALA_EXTERN GType spice_window_get_type (void) G_GNUC_CONST ;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (SpiceWindow, g_object_unref)
static void spice_application_real_open (GApplication* base,
                                  GFile** files,
                                  gint files_length1,
                                  const gchar* hint);
static void spice_application_init (SpiceApplication* self);
VALA_EXTERN gboolean spice_application_is_file_opened (SpiceApplication* self,
                                           GFile* file);
VALA_EXTERN SpiceWindow* spice_application_get_window_from_file (SpiceApplication* self,
                                                     GFile* file);
VALA_EXTERN void spice_window_show_app (SpiceWindow* self);
VALA_EXTERN SpiceWindow* spice_window_new (GtkApplication* app);
VALA_EXTERN SpiceWindow* spice_window_construct (GType object_type,
                                     GtkApplication* app);
VALA_EXTERN void spice_window_open_file (SpiceWindow* self,
                             GFile* file);
static void spice_application_real_activate (GApplication* base);
VALA_EXTERN void spice_window_show_welcome (SpiceWindow* self);
VALA_EXTERN SpiceWindow* spice_application_get_active_spice_window (void);
VALA_EXTERN SpiceApplication* spice_application_get_instance (void);
VALA_EXTERN void spice_application_unregister_file_from_window (SpiceApplication* self,
                                                    GFile* file);
VALA_EXTERN void spice_application_register_file_to_window (SpiceApplication* self,
                                                GFile* file,
                                                SpiceWindow* window);
static gint spice_application_main (gchar** args,
                             gint args_length1);
static gboolean _vala_string_array_contains (gchar* * stack,
                                      gssize stack_length,
                                      const gchar* needle);
VALA_EXTERN SpiceApplication* spice_application_new (void);
VALA_EXTERN SpiceApplication* spice_application_construct (GType object_type);
static GObject * spice_application_constructor (GType type,
                                         guint n_construct_properties,
                                         GObjectConstructParam * construct_properties);
VALA_EXTERN SpiceServicesSettings* spice_services_settings_get_instance (void);
static void spice_application_finalize (GObject * obj);
static GType spice_application_get_type_once (void);
static void _vala_spice_application_get_property (GObject * object,
                                           guint property_id,
                                           GValue * value,
                                           GParamSpec * pspec);
static gssize _vala_array_length (gpointer array);

static inline gpointer
spice_application_get_instance_private (SpiceApplication* self)
{
	return G_STRUCT_MEMBER_P (self, SpiceApplication_private_offset);
}

static gpointer
_g_object_ref0 (gpointer self)
{
	return self ? g_object_ref (self) : NULL;
}

static void
spice_application_real_open (GApplication* base,
                             GFile** files,
                             gint files_length1,
                             const gchar* hint)
{
	SpiceApplication * self;
	self = (SpiceApplication*) base;
	g_return_if_fail (hint != NULL);
	spice_application_init (self);
	{
		GFile** file_collection = NULL;
		gint file_collection_length1 = 0;
		gint _file_collection_size_ = 0;
		gint file_it = 0;
		file_collection = files;
		file_collection_length1 = files_length1;
		for (file_it = 0; file_it < file_collection_length1; file_it = file_it + 1) {
			GFile* _tmp0_;
			GFile* file = NULL;
			_tmp0_ = _g_object_ref0 (file_collection[file_it]);
			file = _tmp0_;
			{
				GFile* _tmp1_;
				_tmp1_ = file;
				if (spice_application_is_file_opened (self, _tmp1_)) {
					SpiceWindow* window = NULL;
					GFile* _tmp2_;
					SpiceWindow* _tmp3_;
					SpiceWindow* _tmp4_;
					_tmp2_ = file;
					_tmp3_ = spice_application_get_window_from_file (self, _tmp2_);
					window = _tmp3_;
					_tmp4_ = window;
					spice_window_show_app (_tmp4_);
					_g_object_unref0 (window);
				} else {
					SpiceWindow* window = NULL;
					SpiceWindow* _tmp5_;
					SpiceWindow* _tmp6_;
					SpiceWindow* _tmp7_;
					GFile* _tmp8_;
					SpiceWindow* _tmp9_;
					_tmp5_ = spice_window_new ((GtkApplication*) self);
					g_object_ref_sink (_tmp5_);
					window = _tmp5_;
					_tmp6_ = window;
					gtk_application_add_window ((GtkApplication*) self, (GtkWindow*) _tmp6_);
					_tmp7_ = window;
					_tmp8_ = file;
					spice_window_open_file (_tmp7_, _tmp8_);
					_tmp9_ = window;
					spice_window_show_app (_tmp9_);
					_g_object_unref0 (window);
				}
				_g_object_unref0 (file);
			}
		}
	}
}

static void
spice_application_init (SpiceApplication* self)
{
	g_return_if_fail (self != NULL);
	if (!self->running) {
		GtkSettings* _tmp0_;
		GtkIconTheme* default_theme = NULL;
		GtkIconTheme* _tmp1_;
		GtkIconTheme* _tmp2_;
		_tmp0_ = gtk_settings_get_default ();
		g_object_set (_tmp0_, "gtk-application-prefer-dark-theme", TRUE, NULL);
		_tmp1_ = gtk_icon_theme_get_default ();
		default_theme = _tmp1_;
		_tmp2_ = default_theme;
		gtk_icon_theme_add_resource_path (_tmp2_, SPICE_APPLICATION_RESOURCE_PATH);
		self->running = TRUE;
	}
}

static void
spice_application_real_activate (GApplication* base)
{
	SpiceApplication * self;
	SpiceWindow* window = NULL;
	SpiceWindow* _tmp0_;
	SpiceWindow* _tmp1_;
	self = (SpiceApplication*) base;
	spice_application_init (self);
	_tmp0_ = spice_window_new ((GtkApplication*) self);
	g_object_ref_sink (_tmp0_);
	window = _tmp0_;
	gtk_application_add_window ((GtkApplication*) self, (GtkWindow*) window);
	spice_window_show_welcome (window);
	_tmp1_ = spice_application_get_active_spice_window ();
	spice_window_show_app (_tmp1_);
	_g_object_unref0 (window);
}

SpiceWindow*
spice_application_get_active_spice_window (void)
{
	SpiceApplication* _tmp0_;
	SpiceApplication* _tmp1_;
	GtkWindow* _tmp2_;
	SpiceWindow* result;
	_tmp0_ = spice_application_get_instance ();
	_tmp1_ = _tmp0_;
	_tmp2_ = gtk_application_get_active_window ((GtkApplication*) _tmp1_);
	result = G_TYPE_CHECK_INSTANCE_CAST (_tmp2_, SPICE_TYPE_WINDOW, SpiceWindow);
	return result;
}

gboolean
spice_application_is_file_opened (SpiceApplication* self,
                                  GFile* file)
{
	GeeHashMap* _tmp0_;
	gchar* _tmp1_;
	gchar* _tmp2_;
	gboolean _tmp3_;
	gboolean result;
	g_return_val_if_fail (self != NULL, FALSE);
	g_return_val_if_fail (file != NULL, FALSE);
	_tmp0_ = self->priv->opened_files;
	_tmp1_ = g_file_get_uri (file);
	_tmp2_ = _tmp1_;
	_tmp3_ = gee_abstract_map_has_key ((GeeAbstractMap*) _tmp0_, _tmp2_);
	_g_free0 (_tmp2_);
	result = _tmp3_;
	return result;
}

void
spice_application_unregister_file_from_window (SpiceApplication* self,
                                               GFile* file)
{
	g_return_if_fail (self != NULL);
	g_return_if_fail (file != NULL);
	if (spice_application_is_file_opened (self, file)) {
		GeeHashMap* _tmp0_;
		gchar* _tmp1_;
		gchar* _tmp2_;
		_tmp0_ = self->priv->opened_files;
		_tmp1_ = g_file_get_uri (file);
		_tmp2_ = _tmp1_;
		gee_abstract_map_unset ((GeeAbstractMap*) _tmp0_, _tmp2_, NULL);
		_g_free0 (_tmp2_);
	}
}

void
spice_application_register_file_to_window (SpiceApplication* self,
                                           GFile* file,
                                           SpiceWindow* window)
{
	g_return_if_fail (self != NULL);
	g_return_if_fail (file != NULL);
	g_return_if_fail (window != NULL);
	if (!spice_application_is_file_opened (self, file)) {
		GeeHashMap* _tmp0_;
		gchar* _tmp1_;
		gchar* _tmp2_;
		_tmp0_ = self->priv->opened_files;
		_tmp1_ = g_file_get_uri (file);
		_tmp2_ = _tmp1_;
		gee_abstract_map_set ((GeeAbstractMap*) _tmp0_, _tmp2_, window);
		_g_free0 (_tmp2_);
	} else {
		g_warning ("Application.vala:115: File was opened in two separate windows");
	}
}

SpiceWindow*
spice_application_get_window_from_file (SpiceApplication* self,
                                        GFile* file)
{
	GeeHashMap* _tmp0_;
	gchar* _tmp1_;
	gchar* _tmp2_;
	gpointer _tmp3_;
	SpiceWindow* _tmp4_;
	SpiceWindow* result;
	g_return_val_if_fail (self != NULL, NULL);
	g_return_val_if_fail (file != NULL, NULL);
	_tmp0_ = self->priv->opened_files;
	_tmp1_ = g_file_get_uri (file);
	_tmp2_ = _tmp1_;
	_tmp3_ = gee_abstract_map_get ((GeeAbstractMap*) _tmp0_, _tmp2_);
	_tmp4_ = (SpiceWindow*) _tmp3_;
	_g_free0 (_tmp2_);
	result = _tmp4_;
	return result;
}

static gboolean
_vala_string_array_contains (gchar* * stack,
                             gssize stack_length,
                             const gchar* needle)
{
	gssize i;
	for (i = 0; i < stack_length; i++) {
		if (g_strcmp0 (stack[i], needle) == 0) {
			return TRUE;
		}
	}
	return FALSE;
}

static gint
spice_application_main (gchar** args,
                        gint args_length1)
{
	gchar** _tmp0_;
	gchar** _tmp1_;
	const gchar* _tmp2_;
	SpiceApplication* application = NULL;
	SpiceApplication* _tmp3_;
	SpiceApplication* _tmp4_;
	SpiceApplication* _tmp5_;
	gint result;
	DEBUG = _vala_string_array_contains (args, args_length1, "-d");
	_tmp1_ = _tmp0_ = g_get_language_names ();
	_tmp2_ = _tmp1_[0];
	setlocale (LC_ALL, _tmp2_);
	g_set_application_name (SPICE_APPLICATION_APP_NAME);
	g_set_prgname (SPICE_APPLICATION_APP_NAME);
	_tmp3_ = spice_application_get_instance ();
	_tmp4_ = _tmp3_;
	_tmp5_ = _g_object_ref0 (_tmp4_);
	application = _tmp5_;
	result = g_application_run ((GApplication*) application, (gint) args_length1, args);
	_g_object_unref0 (application);
	return result;
}

int
main (int argc,
      char ** argv)
{
	return spice_application_main (argv, argc);
}

SpiceApplication*
spice_application_construct (GType object_type)
{
	SpiceApplication * self = NULL;
	self = (SpiceApplication*) g_object_new (object_type, NULL);
	return self;
}

SpiceApplication*
spice_application_new (void)
{
	return spice_application_construct (SPICE_TYPE_APPLICATION);
}

SpiceApplication*
spice_application_get_instance (void)
{
	SpiceApplication* result;
	SpiceApplication* _tmp0_;
	SpiceApplication* _tmp2_;
	_tmp0_ = spice_application__instance;
	if (_tmp0_ == NULL) {
		SpiceApplication* _tmp1_;
		_tmp1_ = spice_application_new ();
		_g_object_unref0 (spice_application__instance);
		spice_application__instance = _tmp1_;
	}
	_tmp2_ = spice_application__instance;
	result = _tmp2_;
	return result;
}

static GObject *
spice_application_constructor (GType type,
                               guint n_construct_properties,
                               GObjectConstructParam * construct_properties)
{
	GObject * obj;
	GObjectClass * parent_class;
	SpiceApplication * self;
	GApplicationFlags _tmp0_;
	GApplicationFlags _tmp1_;
	GeeHashMap* _tmp2_;
	SpiceServicesSettings* _tmp3_;
	parent_class = G_OBJECT_CLASS (spice_application_parent_class);
	obj = parent_class->constructor (type, n_construct_properties, construct_properties);
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, SPICE_TYPE_APPLICATION, SpiceApplication);
	_tmp0_ = g_application_get_flags ((GApplication*) self);
	_tmp1_ = _tmp0_;
	g_application_set_flags ((GApplication*) self, _tmp1_ | G_APPLICATION_HANDLES_OPEN);
	g_application_set_application_id ((GApplication*) self, SPICE_APPLICATION_APP_ID);
	_tmp2_ = gee_hash_map_new (G_TYPE_STRING, (GBoxedCopyFunc) g_strdup, (GDestroyNotify) g_free, SPICE_TYPE_WINDOW, (GBoxedCopyFunc) g_object_ref, (GDestroyNotify) g_object_unref, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL);
	_g_object_unref0 (self->priv->opened_files);
	self->priv->opened_files = _tmp2_;
	_tmp3_ = spice_services_settings_get_instance ();
	_g_object_unref0 (spice_settings);
	spice_settings = _tmp3_;
	return obj;
}

static void
spice_application_class_init (SpiceApplicationClass * klass,
                              gpointer klass_data)
{
	spice_application_parent_class = g_type_class_peek_parent (klass);
	g_type_class_adjust_private_offset (klass, &SpiceApplication_private_offset);
	((GApplicationClass *) klass)->open = (void (*) (GApplication*, GFile**, gint, const gchar*)) spice_application_real_open;
	((GApplicationClass *) klass)->activate = (void (*) (GApplication*)) spice_application_real_activate;
	G_OBJECT_CLASS (klass)->get_property = _vala_spice_application_get_property;
	G_OBJECT_CLASS (klass)->constructor = spice_application_constructor;
	G_OBJECT_CLASS (klass)->finalize = spice_application_finalize;
}

static void
spice_application_instance_init (SpiceApplication * self,
                                 gpointer klass)
{
	self->priv = spice_application_get_instance_private (self);
	self->running = FALSE;
}

static void
spice_application_finalize (GObject * obj)
{
	SpiceApplication * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, SPICE_TYPE_APPLICATION, SpiceApplication);
	_g_object_unref0 (self->priv->opened_files);
	G_OBJECT_CLASS (spice_application_parent_class)->finalize (obj);
}

static GType
spice_application_get_type_once (void)
{
	static const GTypeInfo g_define_type_info = { sizeof (SpiceApplicationClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) spice_application_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (SpiceApplication), 0, (GInstanceInitFunc) spice_application_instance_init, NULL };
	GType spice_application_type_id;
	spice_application_type_id = g_type_register_static (gtk_application_get_type (), "SpiceApplication", &g_define_type_info, 0);
	SpiceApplication_private_offset = g_type_add_instance_private (spice_application_type_id, sizeof (SpiceApplicationPrivate));
	return spice_application_type_id;
}

GType
spice_application_get_type (void)
{
	static volatile gsize spice_application_type_id__once = 0;
	if (g_once_init_enter (&spice_application_type_id__once)) {
		GType spice_application_type_id;
		spice_application_type_id = spice_application_get_type_once ();
		g_once_init_leave (&spice_application_type_id__once, spice_application_type_id);
	}
	return spice_application_type_id__once;
}

static void
_vala_spice_application_get_property (GObject * object,
                                      guint property_id,
                                      GValue * value,
                                      GParamSpec * pspec)
{
	SpiceApplication * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, SPICE_TYPE_APPLICATION, SpiceApplication);
	switch (property_id) {
		default:
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
		break;
	}
}

static gssize
_vala_array_length (gpointer array)
{
	gssize length;
	length = 0;
	if (array) {
		while (((gpointer*) array)[length]) {
			length++;
		}
	}
	return length;
}

